/*
 * This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ********
 * stackframe backtrace
*/
#include <stdio.h>
#include <stdlib.h>
#ifdef __gnu_linux__
#  include <execinfo.h>
#endif
#include "xbacktrace.h"

#define MAX_STACK_FRAMES 20

void xbacktrace(void) {
#ifdef __gnu_linux__
  void *array[MAX_STACK_FRAMES];
  size_t size;
  char **strings;
  size_t i;

  size = backtrace(array, MAX_STACK_FRAMES);
  strings = backtrace_symbols(array, size);

  fprintf(stderr, "last %zd stack frames.\n", size);

  for (i = 0; i < size; i++)
     fprintf(stderr, "%s\n", strings[i]);

  free (strings);
#else
  fprintf(stderr, "backtrace unavailable\n")
#endif
}
