/*
 * This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ********
 * Allocation and die if fail functions
 * Minimal traces enabled if XMALLOC_DEBUG is defined
*/
#ifndef xmalloc_h__
#define xmalloc_h__

#include <stddef.h>
#include "xgnu_extensions.h"

void *xmalloc(size_t) XGNU_ALLOC_SIZE(1) XGNU_RET_NONNULL;
void *xrealloc(void *, size_t) XGNU_ALLOC_SIZE(2) XGNU_RET_NONNULL;
void xfree(void *);
void xfree_and_null(void **) XGNU_NONNULL(1);

#endif /* xmalloc_h__ */