/*
 * This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ********
*/
#ifndef xstring_builder_h__
#define xstring_builder_h__

#include <stddef.h>

#define XSTR_INITIAL_CAPACITY 4096
#define XSTR_EXP_FACTOR ((double) 1.618034)

struct xstring_builder {
  size_t capacity;
  size_t length;
  char *cstr;
};

typedef struct xstring_builder xstring_builder_t;

xstring_builder_t *xstring_builder_new();
void xstring_builder_free(xstring_builder_t *xsb);

xstring_builder_t *xstring_builder_append(xstring_builder_t *xsb,
                                          const char *str, size_t length);
char *xstring_builder_detach_cstring(xstring_builder_t *xsb);

#endif /* xstring_builder_h__ */