#! /bin/bash
#
# This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see <http://www.gnu.org/licenses/>
#

declare _gen_c="n"
declare _gen_h="n"
declare _gen_filelist=""
declare _spath=`dirname "$0"`

for opt in "$@"
do
	case $opt in
		-c)
			_gen_c="y"
			;;
		-h)
			_gen_h="y"
			;;
		-*)
			echo Unlnown option $opt
			echo Usage `basename $0` -c -h [files]
			exit
			;;
		*)
			_gen_filelist="$_gen_filelist $opt"
			;;
	esac
done

if [ "x$_gen_filelist" == "x" ]
then
	echo files missing
	echo Usage $0 -c -h [files]
	exit
fi

if [ "$_gen_h" == "n" -a "$_gen_c" == "n" ]
then
	_gen_h="y"
	_gen_c="y"
fi

for file in $_gen_filelist
do
	if [ "$_gen_h" == "y" ]
	then
		echo GEN $file.h
		if [ -e $file.h ]
		then
			echo "  "file $file.h exists ... skipping
		else
			cat $_spath/template.h | sed "s:TEMPLATE_NAME:$file:g" > $file.h
		fi
	fi
	if [ "$_gen_c" == "y" ]
	then
		echo GEN $file.c
		if [ -e $file.c ]
		then
			echo "  "file $file.c exists ... skipping
		else
			cat $_spath/template.c | sed "s:TEMPLATE_NAME:$file:g" > $file.c
		fi
	fi
done